/**
 * <copyright>
 * </copyright>
 *
 * $Id: MultiplicativeOp.java 8328 2011-08-29 13:37:02Z mjohannes $
 */
package org.openxma.dsl.core.model;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Multiplicative Op</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see org.openxma.dsl.core.CorePackage#getMultiplicativeOp()
 * @model
 * @generated
 */
public enum MultiplicativeOp implements Enumerator {
	/**
     * The '<em><b>NULL</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #NULL_VALUE
     * @generated
     * @ordered
     */
	NULL(0, "NULL", "NULL"), /**
     * The '<em><b>TIMES</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #TIMES_VALUE
     * @generated
     * @ordered
     */
	TIMES(1, "TIMES", "*"),

	/**
     * The '<em><b>DIVIDE</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #DIVIDE_VALUE
     * @generated
     * @ordered
     */
	DIVIDE(2, "DIVIDE", "/");

	/**
     * The '<em><b>NULL</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>NULL</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #NULL
     * @model
     * @generated
     * @ordered
     */
	public static final int NULL_VALUE = 0;

	/**
     * The '<em><b>TIMES</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>TIMES</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #TIMES
     * @model literal="*"
     * @generated
     * @ordered
     */
	public static final int TIMES_VALUE = 1;

	/**
     * The '<em><b>DIVIDE</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>DIVIDE</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #DIVIDE
     * @model literal="/"
     * @generated
     * @ordered
     */
	public static final int DIVIDE_VALUE = 2;

	/**
     * An array of all the '<em><b>Multiplicative Op</b></em>' enumerators.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private static final MultiplicativeOp[] VALUES_ARRAY =
		new MultiplicativeOp[] {
            NULL,
            TIMES,
            DIVIDE,
        };

	/**
     * A public read-only list of all the '<em><b>Multiplicative Op</b></em>' enumerators.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static final List<MultiplicativeOp> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
     * Returns the '<em><b>Multiplicative Op</b></em>' literal with the specified literal value.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static MultiplicativeOp get(String literal) {
        for (int i = 0; i < VALUES_ARRAY.length; ++i) {
            MultiplicativeOp result = VALUES_ARRAY[i];
            if (result.toString().equals(literal)) {
                return result;
            }
        }
        return null;
    }

	/**
     * Returns the '<em><b>Multiplicative Op</b></em>' literal with the specified name.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static MultiplicativeOp getByName(String name) {
        for (int i = 0; i < VALUES_ARRAY.length; ++i) {
            MultiplicativeOp result = VALUES_ARRAY[i];
            if (result.getName().equals(name)) {
                return result;
            }
        }
        return null;
    }

	/**
     * Returns the '<em><b>Multiplicative Op</b></em>' literal with the specified integer value.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static MultiplicativeOp get(int value) {
        switch (value) {
            case NULL_VALUE: return NULL;
            case TIMES_VALUE: return TIMES;
            case DIVIDE_VALUE: return DIVIDE;
        }
        return null;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private final int value;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private final String name;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private final String literal;

	/**
     * Only this class can construct instances.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private MultiplicativeOp(int value, String name, String literal) {
        this.value = value;
        this.name = name;
        this.literal = literal;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public int getValue() {
      return value;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public String getName() {
      return name;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public String getLiteral() {
      return literal;
    }

	/**
     * Returns the literal value of the enumerator, which is its string representation.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public String toString() {
        return literal;
    }
	
} //MultiplicativeOp
